/***************************************************************************
*                           xpm2xrally.cpp  -  description                 *
*                              -------------------                         *
*                           begin                : Sun Apr 2 2000          *
*                           copyright            : (C) 2000 by Perdig      *
*                           email                : perdig@linuxbr.com.br   *
****************************************************************************/
 
/***************************************************************************
*                                                                          *
*                                                                          *
*                                                                          *
*   This program is free software; you can redistribute it and/or modify   *
*   it under the terms of the GNU General Public License as published by   *
*   the Free Software Foundation; either version 2 of the License, or      *
*   (at your option) any later version.                                    *
*                                                                          *
*                                                                          *
*                                                                          *
***************************************************************************/

#include <stdio.h>

int main(int argc, char *argv[]) {
	FILE *f;
	int w = 0, h = 0;
	char buffer[256];
	char *map;
	char blue = 0, yellow = 0, black = 0, white = 0, red = 0;
	char temp, tbuffer[10];
	int x = 0, y = 0, c = 0, a = 0;
	f = fopen(argv[1], "r");
	
	// Get width and height of xpm
	while ( w == 0 && h == 0) {
		fgets(buffer, 256, f);
		sscanf(buffer, "\"%d %d %d", &w, &h, &c);
	}
	
	// Get colors
	for (a = 0; a < c; a++) {
		fgets(buffer, 256, f);
		sscanf(buffer, "\"%c c %7s", &temp, &tbuffer);
		if (!strcasecmp(tbuffer, "#0000ff"))
			blue = temp;
		if (!strcasecmp(tbuffer, "#ffff00"))
			yellow = temp;
		if (!strcasecmp(tbuffer, "#000000"))
			black = temp;
		if (!strcasecmp(tbuffer, "#ffffff") || !strcasecmp(tbuffer, "None\","))
			white = temp;
		if (!strcasecmp(tbuffer, "#ff0000"))
			red = temp;	
	}

	// Alloc memory
	map = (char *)malloc(w * h * sizeof(char));

	// Get the first caracter
  temp = 0;
	while (temp != '"')
		temp = fgetc(f);

	// Print the width / height
	printf("-\nsize %d %d\n", w, h);
	
	// Print the map
	for (y = 0; y < h; y++) {
		for (x = 0; x < w; x++) {
			temp = fgetc(f);
			while (temp == '"' || temp == ',' || temp == 10 || temp == 13)
				temp = fgetc(f);
			if (temp == blue)
				map[x] = 'D';
			else if (temp == yellow)
				map[x] = 'F';
			else if (temp == black)
				map[x] = '1';
			else if (temp == white)
				map[x] = '0';
			else if (temp == red)
				map[x] = 'A';
			else
				map[x] = '0';
		}
		printf("%s\n", map);
	}

}

